//+------------------------------------------------------------------+
//|                                                   Gap_Trader.mq4 |
//|                                            http://www.doshur.com |
//+------------------------------------------------------------------+
#property copyright "doshur"
#property link      "http://www.doshur.com"

extern int GapRange = 10;

extern double SL_Factor = 2;
extern double TP_Factor = 1;
extern double Risk = 0.1;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//---- GAP

   bool GAP = false;

   double PrevClose = iClose(NULL, 0, 1);
   double CurrOpen = iOpen(NULL, 0, 0);

   double Range = MathAbs(PrevClose - CurrOpen);

   if(Range >= GapRange * Point * 10) GAP = true;

//---- TP / SL
   
   double ATR = iATR(NULL, 0, 13, 0);

   double StopLoss = ATR * SL_Factor;
   double TakeProfit = ATR * TP_Factor;

//---- TRADE

   if(COT(1, 101187) == 0 && GAP == true && CurrOpen < PrevClose)
   {
      OrderSend(Symbol(), OP_BUY, LotSize(Risk), Ask, 3, Ask - StopLoss, Ask + TakeProfit, "Gap_Trader.B", 101187, 0, Blue);
   }

   if(COT(2, 201187) == 0 && GAP == true && CurrOpen > PrevClose)
   {
      OrderSend(Symbol(), OP_SELL, LotSize(Risk), Bid, 3, Bid + StopLoss, Bid - TakeProfit, "Gap_Trader.S", 201187, 0, Red);
   }

//----
   return(0);
  }
//+------------------------------------------------------------------+
//+ Check Open Trades                                                |
//+------------------------------------------------------------------+
int COT(int BS, int MN)
{
   int Buys = 0, Sells = 0;

   for(int cnt_COT = 0; cnt_COT < OrdersTotal(); cnt_COT++)
   {
      OrderSelect(cnt_COT, SELECT_BY_POS, MODE_TRADES);

      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MN && OrderType() == OP_BUY) Buys++;
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MN && OrderType() == OP_SELL) Sells++;
   }

   if(BS == 1) return(Buys);
   if(BS == 2) return(Sells);
}
//+------------------------------------------------------------------+
//| LotSize                                                          |
//+------------------------------------------------------------------+
double LotSize(double Risk)
{
   double Size = Risk * MathSqrt(AccountBalance() / 1000);
   double MinLot = MarketInfo(Symbol(), MODE_MINLOT);

   if(Size < MinLot) Size = MinLot;

   return(NormalizeDouble(Size, 2));
}